diff --git a/hcache/hcache.c b/hcache/hcache.c
index 1cce73359b..6b6719a53f 100644
--- a/hcache/hcache.c
+++ b/hcache/hcache.c
@@ -320,7 +320,6 @@ static unsigned char *dump_buffer(struct Buffer *b, unsigned char *d, int *off,
   d = dump_char_size(b->data, d, off, b->dsize + 1, convert);
   d = dump_int(b->dptr - b->data, d, off);
   d = dump_int(b->dsize, d, off);
-  d = dump_int(b->destroy, d, off);
 
   return d;
 }
@@ -342,8 +341,6 @@ static void restore_buffer(struct Buffer **b, const unsigned char *d, int *off,
   mutt_buffer_seek(*b, offset);
   restore_int(&used, d, off);
   (*b)->dsize = used;
-  restore_int(&used, d, off);
-  (*b)->destroy = used;
 }
 
 static unsigned char *dump_parameter(struct Parameter *p, unsigned char *d,
diff --git a/init.c b/init.c
index c02bae65a9..417461b3ad 100644
--- a/init.c
+++ b/init.c
@@ -595,9 +595,7 @@ int mutt_extract_token(struct Buffer *dest, struct Buffer *tok, int flags)
     {
       FILE *fp = NULL;
       pid_t pid;
-      char *cmd = NULL, *ptr = NULL;
-      size_t expnlen;
-      struct Buffer expn;
+      char *cmd = NULL;
       int line = 0;
 
       pc = tok->dptr;
@@ -628,8 +626,9 @@ int mutt_extract_token(struct Buffer *dest, struct Buffer *tok, int flags)
       tok->dptr = pc + 1;
 
       /* read line */
-      mutt_buffer_init(&expn);
-      expn.data = mutt_file_read_line(NULL, &expn.dsize, fp, &line, 0);
+      size_t dummy;
+      char *filter_out = mutt_file_read_line(NULL, &dummy, fp, &line, 0);
+      size_t filter_out_len = mutt_str_strlen(filter_out);
       mutt_file_fclose(&fp);
       mutt_wait_filter(pid);
 
@@ -637,25 +636,22 @@ int mutt_extract_token(struct Buffer *dest, struct Buffer *tok, int flags)
          plus whatever else was left on the original line */
       /* BUT: If this is inside a quoted string, directly add output to
        * the token */
-      if (expn.data && qc)
+      if (filter_out)
       {
-        mutt_buffer_addstr(dest, expn.data);
-        FREE(&expn.data);
-      }
-      else if (expn.data)
-      {
-        expnlen = mutt_str_strlen(expn.data);
-        tok->dsize = expnlen + mutt_str_strlen(tok->dptr) + 1;
-        ptr = mutt_mem_malloc(tok->dsize);
-        memcpy(ptr, expn.data, expnlen);
-        strcpy(ptr + expnlen, tok->dptr);
-        if (tok->destroy)
-          FREE(&tok->data);
-        tok->data = ptr;
-        tok->dptr = ptr;
-        tok->destroy = 1; /* mark that the caller should destroy this data */
-        ptr = NULL;
-        FREE(&expn.data);
+        if (qc)
+        {
+          mutt_buffer_add(dest, filter_out, filter_out_len);
+        }
+        else
+        {
+          mutt_buffer_deinit(tok);
+          tok->dsize = filter_out_len + mutt_str_strlen(tok->dptr) + 1;
+          char *ptr = mutt_mem_malloc(tok->dsize);
+          memcpy(ptr, filter_out, filter_out_len);
+          strcpy(ptr + filter_out_len, tok->dptr);
+          tok->data = tok->dptr = ptr;
+        }
+        FREE(&filter_out);
       }
     }
     else if (ch == '$' && (!qc || qc == '"') &&
@@ -3287,8 +3283,8 @@ int mutt_parse_rc_line(/* const */ char *line, struct Buffer *token, struct Buff
   if (!line || !*line)
     return 0;
 
-  expn.data = expn.dptr = line;
-  expn.dsize = mutt_str_strlen(line);
+  mutt_buffer_addstr(&expn, line);
+  mutt_buffer_rewind(&expn);
 
   *err->data = 0;
 
@@ -3323,8 +3319,7 @@ int mutt_parse_rc_line(/* const */ char *line, struct Buffer *token, struct Buff
     }
   }
 finish:
-  if (expn.destroy)
-    FREE(&expn.data);
+  mutt_buffer_deinit(&expn);
   return r;
 }
 
diff --git a/mutt/buffer.c b/mutt/buffer.c
index 0f41c4bdc0..33074522dd 100644
--- a/mutt/buffer.c
+++ b/mutt/buffer.c
@@ -107,7 +107,7 @@ void mutt_buffer_from(struct Buffer *buf, char *seed)
  * Always one byte bigger than necessary for the null terminator, and the
  * buffer is always NUL-terminated
  */
-static void mutt_buffer_add(struct Buffer *buf, const char *s, size_t len)
+void mutt_buffer_add(struct Buffer *buf, const char *s, size_t len)
 {
   if (!buf || !s)
     return;
diff --git a/mutt/buffer.h b/mutt/buffer.h
index 069150a196..3aeeabcfa2 100644
--- a/mutt/buffer.h
+++ b/mutt/buffer.h
@@ -34,13 +34,13 @@ struct Buffer
   char *data;   /**< pointer to data */
   char *dptr;   /**< current read/write position */
   size_t dsize; /**< length of data */
-  int destroy;  /**< destroy 'data' when done? */
 };
 
 #define MoreArgs(p) (*(p)->dptr && (*(p)->dptr != ';') && (*(p)->dptr != '#'))
 
 void mutt_buffer_init(struct Buffer *buf);
 void mutt_buffer_deinit(struct Buffer *buf);
+void mutt_buffer_add(struct Buffer *buf, const char *s, size_t len);
 void mutt_buffer_addch(struct Buffer *buf, char c);
 void mutt_buffer_addstr(struct Buffer *buf, const char *s);
 void mutt_buffer_from(struct Buffer *buf, char *seed);
